import {
  AddedPrincipal,
  AddressAttribute,
  AddressAttributeName,
  ByoipCidr,
  CapacityReservationInstancePlatform,
  ClientVpnAuthorizationRuleStatus,
  CurrencyCodeValues,
  IamInstanceProfileAssociation,
  IamInstanceProfileSpecification,
  IpPermission,
  NatGatewayAddress,
  PortRange,
  RouteTableAssociationState,
  TagSpecification,
  TransitGatewayAttachmentResourceType,
  TransitGatewayMulticastDomainAssociations,
  TransitGatewayPeeringAttachment,
  TransitGatewayVpcAttachment,
  UnsuccessfulItem,
  VerifiedAccessTrustProvider,
} from "./models_0";
import {
  _InstanceType,
  AmdSevSnpSpecification,
  BlockDeviceMapping,
  CapacityReservation,
  CreditSpecificationRequest,
  ElasticGpuSpecification,
  HostnameType,
  IcmpTypeCode,
  InstanceInterruptionBehavior,
  InstanceIpv6Address,
  LocalGatewayRoute,
  ManagedPrefixList,
  MarketType,
  OperatorRequest,
  Placement,
  RuleAction,
  ShutdownBehavior,
  SpotInstanceType,
  VolumeType,
} from "./models_1";
import {
  DnsOptionsSpecification,
  IKEVersionsRequestListValue,
  IpAddressType,
  PayerResponsibility,
  Phase1DHGroupNumbersRequestListValue,
  Phase1EncryptionAlgorithmsRequestListValue,
  Phase1IntegrityAlgorithmsRequestListValue,
  Phase2DHGroupNumbersRequestListValue,
  Phase2EncryptionAlgorithmsRequestListValue,
  Phase2IntegrityAlgorithmsRequestListValue,
  SnapshotState,
  SSEType,
  SubnetConfiguration,
  TransitGatewayRoute,
  VerifiedAccessSseSpecificationRequest,
  VpnConnection,
  VpnTunnelLogOptionsSpecification,
} from "./models_2";
import {
  Byoasn,
  ClientVpnConnectionStatus,
  Filter,
  InstanceTagNotificationAttribute,
  IpamPoolCidr,
} from "./models_3";
import {
  ArchitectureValues,
  AttributeBooleanValue,
  BootModeValues,
  HttpTokensState,
  ImdsSupportValues,
  InstanceAttributeName,
  InstanceAutoRecoveryState,
  InstanceMetadataEndpointState,
  InstanceMetadataProtocolState,
  InstanceMetadataTagsState,
  InstanceState,
  Monitoring,
  NetworkInsightsAccessScopeAnalysis,
  NetworkInsightsAnalysis,
  PublicIpv4PoolRange,
  ScheduledInstance,
  SnapshotAttributeName,
  TpmSupportValues,
} from "./models_4";
import {
  InstanceNetworkInterfaceSpecification,
  RunInstancesMonitoringEnabled,
  SpotFleetRequestConfigData,
  SpotInstanceRequest,
  SpotPlacement,
  VolumeModification,
} from "./models_5";
import { CapacityReservationSpecification, Purchase } from "./models_6";
export interface ModifyVerifiedAccessTrustProviderDeviceOptions {
  PublicSigningKeyUrl?: string | undefined;
}
export interface ModifyVerifiedAccessTrustProviderOidcOptions {
  Issuer?: string | undefined;
  AuthorizationEndpoint?: string | undefined;
  TokenEndpoint?: string | undefined;
  UserInfoEndpoint?: string | undefined;
  ClientId?: string | undefined;
  ClientSecret?: string | undefined;
  Scope?: string | undefined;
}
export interface ModifyVerifiedAccessTrustProviderRequest {
  VerifiedAccessTrustProviderId: string | undefined;
  OidcOptions?: ModifyVerifiedAccessTrustProviderOidcOptions | undefined;
  DeviceOptions?: ModifyVerifiedAccessTrustProviderDeviceOptions | undefined;
  Description?: string | undefined;
  DryRun?: boolean | undefined;
  ClientToken?: string | undefined;
  SseSpecification?: VerifiedAccessSseSpecificationRequest | undefined;
}
export interface ModifyVerifiedAccessTrustProviderResult {
  VerifiedAccessTrustProvider?: VerifiedAccessTrustProvider | undefined;
}
export interface ModifyVolumeRequest {
  DryRun?: boolean | undefined;
  VolumeId: string | undefined;
  Size?: number | undefined;
  VolumeType?: VolumeType | undefined;
  Iops?: number | undefined;
  Throughput?: number | undefined;
  MultiAttachEnabled?: boolean | undefined;
}
export interface ModifyVolumeResult {
  VolumeModification?: VolumeModification | undefined;
}
export interface ModifyVolumeAttributeRequest {
  AutoEnableIO?: AttributeBooleanValue | undefined;
  VolumeId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyVpcAttributeRequest {
  EnableDnsHostnames?: AttributeBooleanValue | undefined;
  EnableDnsSupport?: AttributeBooleanValue | undefined;
  VpcId: string | undefined;
  EnableNetworkAddressUsageMetrics?: AttributeBooleanValue | undefined;
}
export interface ModifyVpcEndpointRequest {
  DryRun?: boolean | undefined;
  VpcEndpointId: string | undefined;
  ResetPolicy?: boolean | undefined;
  PolicyDocument?: string | undefined;
  AddRouteTableIds?: string[] | undefined;
  RemoveRouteTableIds?: string[] | undefined;
  AddSubnetIds?: string[] | undefined;
  RemoveSubnetIds?: string[] | undefined;
  AddSecurityGroupIds?: string[] | undefined;
  RemoveSecurityGroupIds?: string[] | undefined;
  IpAddressType?: IpAddressType | undefined;
  DnsOptions?: DnsOptionsSpecification | undefined;
  PrivateDnsEnabled?: boolean | undefined;
  SubnetConfigurations?: SubnetConfiguration[] | undefined;
}
export interface ModifyVpcEndpointResult {
  Return?: boolean | undefined;
}
export interface ModifyVpcEndpointConnectionNotificationRequest {
  DryRun?: boolean | undefined;
  ConnectionNotificationId: string | undefined;
  ConnectionNotificationArn?: string | undefined;
  ConnectionEvents?: string[] | undefined;
}
export interface ModifyVpcEndpointConnectionNotificationResult {
  ReturnValue?: boolean | undefined;
}
export interface ModifyVpcEndpointServiceConfigurationRequest {
  DryRun?: boolean | undefined;
  ServiceId: string | undefined;
  PrivateDnsName?: string | undefined;
  RemovePrivateDnsName?: boolean | undefined;
  AcceptanceRequired?: boolean | undefined;
  AddNetworkLoadBalancerArns?: string[] | undefined;
  RemoveNetworkLoadBalancerArns?: string[] | undefined;
  AddGatewayLoadBalancerArns?: string[] | undefined;
  RemoveGatewayLoadBalancerArns?: string[] | undefined;
  AddSupportedIpAddressTypes?: string[] | undefined;
  RemoveSupportedIpAddressTypes?: string[] | undefined;
}
export interface ModifyVpcEndpointServiceConfigurationResult {
  Return?: boolean | undefined;
}
export interface ModifyVpcEndpointServicePayerResponsibilityRequest {
  DryRun?: boolean | undefined;
  ServiceId: string | undefined;
  PayerResponsibility: PayerResponsibility | undefined;
}
export interface ModifyVpcEndpointServicePayerResponsibilityResult {
  ReturnValue?: boolean | undefined;
}
export interface ModifyVpcEndpointServicePermissionsRequest {
  DryRun?: boolean | undefined;
  ServiceId: string | undefined;
  AddAllowedPrincipals?: string[] | undefined;
  RemoveAllowedPrincipals?: string[] | undefined;
}
export interface ModifyVpcEndpointServicePermissionsResult {
  AddedPrincipals?: AddedPrincipal[] | undefined;
  ReturnValue?: boolean | undefined;
}
export interface PeeringConnectionOptionsRequest {
  AllowDnsResolutionFromRemoteVpc?: boolean | undefined;
  AllowEgressFromLocalClassicLinkToRemoteVpc?: boolean | undefined;
  AllowEgressFromLocalVpcToRemoteClassicLink?: boolean | undefined;
}
export interface ModifyVpcPeeringConnectionOptionsRequest {
  AccepterPeeringConnectionOptions?:
    | PeeringConnectionOptionsRequest
    | undefined;
  DryRun?: boolean | undefined;
  RequesterPeeringConnectionOptions?:
    | PeeringConnectionOptionsRequest
    | undefined;
  VpcPeeringConnectionId: string | undefined;
}
export interface PeeringConnectionOptions {
  AllowDnsResolutionFromRemoteVpc?: boolean | undefined;
  AllowEgressFromLocalClassicLinkToRemoteVpc?: boolean | undefined;
  AllowEgressFromLocalVpcToRemoteClassicLink?: boolean | undefined;
}
export interface ModifyVpcPeeringConnectionOptionsResult {
  AccepterPeeringConnectionOptions?: PeeringConnectionOptions | undefined;
  RequesterPeeringConnectionOptions?: PeeringConnectionOptions | undefined;
}
export declare const VpcTenancy: {
  readonly default: "default";
};
export type VpcTenancy = (typeof VpcTenancy)[keyof typeof VpcTenancy];
export interface ModifyVpcTenancyRequest {
  VpcId: string | undefined;
  InstanceTenancy: VpcTenancy | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyVpcTenancyResult {
  ReturnValue?: boolean | undefined;
}
export interface ModifyVpnConnectionRequest {
  VpnConnectionId: string | undefined;
  TransitGatewayId?: string | undefined;
  CustomerGatewayId?: string | undefined;
  VpnGatewayId?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyVpnConnectionResult {
  VpnConnection?: VpnConnection | undefined;
}
export interface ModifyVpnConnectionOptionsRequest {
  VpnConnectionId: string | undefined;
  LocalIpv4NetworkCidr?: string | undefined;
  RemoteIpv4NetworkCidr?: string | undefined;
  LocalIpv6NetworkCidr?: string | undefined;
  RemoteIpv6NetworkCidr?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyVpnConnectionOptionsResult {
  VpnConnection?: VpnConnection | undefined;
}
export interface ModifyVpnTunnelCertificateRequest {
  VpnConnectionId: string | undefined;
  VpnTunnelOutsideIpAddress: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyVpnTunnelCertificateResult {
  VpnConnection?: VpnConnection | undefined;
}
export interface ModifyVpnTunnelOptionsSpecification {
  TunnelInsideCidr?: string | undefined;
  TunnelInsideIpv6Cidr?: string | undefined;
  PreSharedKey?: string | undefined;
  Phase1LifetimeSeconds?: number | undefined;
  Phase2LifetimeSeconds?: number | undefined;
  RekeyMarginTimeSeconds?: number | undefined;
  RekeyFuzzPercentage?: number | undefined;
  ReplayWindowSize?: number | undefined;
  DPDTimeoutSeconds?: number | undefined;
  DPDTimeoutAction?: string | undefined;
  Phase1EncryptionAlgorithms?:
    | Phase1EncryptionAlgorithmsRequestListValue[]
    | undefined;
  Phase2EncryptionAlgorithms?:
    | Phase2EncryptionAlgorithmsRequestListValue[]
    | undefined;
  Phase1IntegrityAlgorithms?:
    | Phase1IntegrityAlgorithmsRequestListValue[]
    | undefined;
  Phase2IntegrityAlgorithms?:
    | Phase2IntegrityAlgorithmsRequestListValue[]
    | undefined;
  Phase1DHGroupNumbers?: Phase1DHGroupNumbersRequestListValue[] | undefined;
  Phase2DHGroupNumbers?: Phase2DHGroupNumbersRequestListValue[] | undefined;
  IKEVersions?: IKEVersionsRequestListValue[] | undefined;
  StartupAction?: string | undefined;
  LogOptions?: VpnTunnelLogOptionsSpecification | undefined;
  EnableTunnelLifecycleControl?: boolean | undefined;
}
export interface ModifyVpnTunnelOptionsRequest {
  VpnConnectionId: string | undefined;
  VpnTunnelOutsideIpAddress: string | undefined;
  TunnelOptions: ModifyVpnTunnelOptionsSpecification | undefined;
  DryRun?: boolean | undefined;
  SkipTunnelReplacement?: boolean | undefined;
}
export interface ModifyVpnTunnelOptionsResult {
  VpnConnection?: VpnConnection | undefined;
}
export interface MonitorInstancesRequest {
  InstanceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface InstanceMonitoring {
  InstanceId?: string | undefined;
  Monitoring?: Monitoring | undefined;
}
export interface MonitorInstancesResult {
  InstanceMonitorings?: InstanceMonitoring[] | undefined;
}
export interface MoveAddressToVpcRequest {
  DryRun?: boolean | undefined;
  PublicIp: string | undefined;
}
export declare const Status: {
  readonly inClassic: "InClassic";
  readonly inVpc: "InVpc";
  readonly moveInProgress: "MoveInProgress";
};
export type Status = (typeof Status)[keyof typeof Status];
export interface MoveAddressToVpcResult {
  AllocationId?: string | undefined;
  Status?: Status | undefined;
}
export interface MoveByoipCidrToIpamRequest {
  DryRun?: boolean | undefined;
  Cidr: string | undefined;
  IpamPoolId: string | undefined;
  IpamPoolOwner: string | undefined;
}
export interface MoveByoipCidrToIpamResult {
  ByoipCidr?: ByoipCidr | undefined;
}
export interface MoveCapacityReservationInstancesRequest {
  DryRun?: boolean | undefined;
  ClientToken?: string | undefined;
  SourceCapacityReservationId: string | undefined;
  DestinationCapacityReservationId: string | undefined;
  InstanceCount: number | undefined;
}
export interface MoveCapacityReservationInstancesResult {
  SourceCapacityReservation?: CapacityReservation | undefined;
  DestinationCapacityReservation?: CapacityReservation | undefined;
  InstanceCount?: number | undefined;
}
export interface CidrAuthorizationContext {
  Message: string | undefined;
  Signature: string | undefined;
}
export interface ProvisionByoipCidrRequest {
  Cidr: string | undefined;
  CidrAuthorizationContext?: CidrAuthorizationContext | undefined;
  PubliclyAdvertisable?: boolean | undefined;
  Description?: string | undefined;
  DryRun?: boolean | undefined;
  PoolTagSpecifications?: TagSpecification[] | undefined;
  MultiRegion?: boolean | undefined;
  NetworkBorderGroup?: string | undefined;
}
export interface ProvisionByoipCidrResult {
  ByoipCidr?: ByoipCidr | undefined;
}
export interface AsnAuthorizationContext {
  Message: string | undefined;
  Signature: string | undefined;
}
export interface ProvisionIpamByoasnRequest {
  DryRun?: boolean | undefined;
  IpamId: string | undefined;
  Asn: string | undefined;
  AsnAuthorizationContext: AsnAuthorizationContext | undefined;
}
export interface ProvisionIpamByoasnResult {
  Byoasn?: Byoasn | undefined;
}
export interface IpamCidrAuthorizationContext {
  Message?: string | undefined;
  Signature?: string | undefined;
}
export declare const VerificationMethod: {
  readonly dns_token: "dns-token";
  readonly remarks_x509: "remarks-x509";
};
export type VerificationMethod =
  (typeof VerificationMethod)[keyof typeof VerificationMethod];
export interface ProvisionIpamPoolCidrRequest {
  DryRun?: boolean | undefined;
  IpamPoolId: string | undefined;
  Cidr?: string | undefined;
  CidrAuthorizationContext?: IpamCidrAuthorizationContext | undefined;
  NetmaskLength?: number | undefined;
  ClientToken?: string | undefined;
  VerificationMethod?: VerificationMethod | undefined;
  IpamExternalResourceVerificationTokenId?: string | undefined;
}
export interface ProvisionIpamPoolCidrResult {
  IpamPoolCidr?: IpamPoolCidr | undefined;
}
export interface ProvisionPublicIpv4PoolCidrRequest {
  DryRun?: boolean | undefined;
  IpamPoolId: string | undefined;
  PoolId: string | undefined;
  NetmaskLength: number | undefined;
  NetworkBorderGroup?: string | undefined;
}
export interface ProvisionPublicIpv4PoolCidrResult {
  PoolId?: string | undefined;
  PoolAddressRange?: PublicIpv4PoolRange | undefined;
}
export interface PurchaseCapacityBlockRequest {
  DryRun?: boolean | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  CapacityBlockOfferingId: string | undefined;
  InstancePlatform: CapacityReservationInstancePlatform | undefined;
}
export interface PurchaseCapacityBlockResult {
  CapacityReservation?: CapacityReservation | undefined;
}
export interface PurchaseHostReservationRequest {
  ClientToken?: string | undefined;
  CurrencyCode?: CurrencyCodeValues | undefined;
  HostIdSet: string[] | undefined;
  LimitPrice?: string | undefined;
  OfferingId: string | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
}
export interface PurchaseHostReservationResult {
  ClientToken?: string | undefined;
  CurrencyCode?: CurrencyCodeValues | undefined;
  Purchase?: Purchase[] | undefined;
  TotalHourlyPrice?: string | undefined;
  TotalUpfrontPrice?: string | undefined;
}
export interface ReservedInstanceLimitPrice {
  Amount?: number | undefined;
  CurrencyCode?: CurrencyCodeValues | undefined;
}
export interface PurchaseReservedInstancesOfferingRequest {
  InstanceCount: number | undefined;
  ReservedInstancesOfferingId: string | undefined;
  PurchaseTime?: Date | undefined;
  DryRun?: boolean | undefined;
  LimitPrice?: ReservedInstanceLimitPrice | undefined;
}
export interface PurchaseReservedInstancesOfferingResult {
  ReservedInstancesId?: string | undefined;
}
export interface PurchaseRequest {
  InstanceCount: number | undefined;
  PurchaseToken: string | undefined;
}
export interface PurchaseScheduledInstancesRequest {
  ClientToken?: string | undefined;
  DryRun?: boolean | undefined;
  PurchaseRequests: PurchaseRequest[] | undefined;
}
export interface PurchaseScheduledInstancesResult {
  ScheduledInstanceSet?: ScheduledInstance[] | undefined;
}
export interface RebootInstancesRequest {
  InstanceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface RegisterImageRequest {
  ImageLocation?: string | undefined;
  BillingProducts?: string[] | undefined;
  BootMode?: BootModeValues | undefined;
  TpmSupport?: TpmSupportValues | undefined;
  UefiData?: string | undefined;
  ImdsSupport?: ImdsSupportValues | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  DryRun?: boolean | undefined;
  Name: string | undefined;
  Description?: string | undefined;
  Architecture?: ArchitectureValues | undefined;
  KernelId?: string | undefined;
  RamdiskId?: string | undefined;
  RootDeviceName?: string | undefined;
  BlockDeviceMappings?: BlockDeviceMapping[] | undefined;
  VirtualizationType?: string | undefined;
  SriovNetSupport?: string | undefined;
  EnaSupport?: boolean | undefined;
}
export interface RegisterImageResult {
  ImageId?: string | undefined;
}
export interface RegisterInstanceTagAttributeRequest {
  IncludeAllTagsOfInstance?: boolean | undefined;
  InstanceTagKeys?: string[] | undefined;
}
export interface RegisterInstanceEventNotificationAttributesRequest {
  DryRun?: boolean | undefined;
  InstanceTagAttribute: RegisterInstanceTagAttributeRequest | undefined;
}
export interface RegisterInstanceEventNotificationAttributesResult {
  InstanceTagAttribute?: InstanceTagNotificationAttribute | undefined;
}
export interface RegisterTransitGatewayMulticastGroupMembersRequest {
  TransitGatewayMulticastDomainId: string | undefined;
  GroupIpAddress?: string | undefined;
  NetworkInterfaceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayMulticastRegisteredGroupMembers {
  TransitGatewayMulticastDomainId?: string | undefined;
  RegisteredNetworkInterfaceIds?: string[] | undefined;
  GroupIpAddress?: string | undefined;
}
export interface RegisterTransitGatewayMulticastGroupMembersResult {
  RegisteredMulticastGroupMembers?:
    | TransitGatewayMulticastRegisteredGroupMembers
    | undefined;
}
export interface RegisterTransitGatewayMulticastGroupSourcesRequest {
  TransitGatewayMulticastDomainId: string | undefined;
  GroupIpAddress?: string | undefined;
  NetworkInterfaceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayMulticastRegisteredGroupSources {
  TransitGatewayMulticastDomainId?: string | undefined;
  RegisteredNetworkInterfaceIds?: string[] | undefined;
  GroupIpAddress?: string | undefined;
}
export interface RegisterTransitGatewayMulticastGroupSourcesResult {
  RegisteredMulticastGroupSources?:
    | TransitGatewayMulticastRegisteredGroupSources
    | undefined;
}
export interface RejectCapacityReservationBillingOwnershipRequest {
  DryRun?: boolean | undefined;
  CapacityReservationId: string | undefined;
}
export interface RejectCapacityReservationBillingOwnershipResult {
  Return?: boolean | undefined;
}
export interface RejectTransitGatewayMulticastDomainAssociationsRequest {
  TransitGatewayMulticastDomainId?: string | undefined;
  TransitGatewayAttachmentId?: string | undefined;
  SubnetIds?: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface RejectTransitGatewayMulticastDomainAssociationsResult {
  Associations?: TransitGatewayMulticastDomainAssociations | undefined;
}
export interface RejectTransitGatewayPeeringAttachmentRequest {
  TransitGatewayAttachmentId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface RejectTransitGatewayPeeringAttachmentResult {
  TransitGatewayPeeringAttachment?: TransitGatewayPeeringAttachment | undefined;
}
export interface RejectTransitGatewayVpcAttachmentRequest {
  TransitGatewayAttachmentId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface RejectTransitGatewayVpcAttachmentResult {
  TransitGatewayVpcAttachment?: TransitGatewayVpcAttachment | undefined;
}
export interface RejectVpcEndpointConnectionsRequest {
  DryRun?: boolean | undefined;
  ServiceId: string | undefined;
  VpcEndpointIds: string[] | undefined;
}
export interface RejectVpcEndpointConnectionsResult {
  Unsuccessful?: UnsuccessfulItem[] | undefined;
}
export interface RejectVpcPeeringConnectionRequest {
  DryRun?: boolean | undefined;
  VpcPeeringConnectionId: string | undefined;
}
export interface RejectVpcPeeringConnectionResult {
  Return?: boolean | undefined;
}
export interface ReleaseAddressRequest {
  AllocationId?: string | undefined;
  PublicIp?: string | undefined;
  NetworkBorderGroup?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ReleaseHostsRequest {
  HostIds: string[] | undefined;
}
export interface ReleaseHostsResult {
  Successful?: string[] | undefined;
  Unsuccessful?: UnsuccessfulItem[] | undefined;
}
export interface ReleaseIpamPoolAllocationRequest {
  DryRun?: boolean | undefined;
  IpamPoolId: string | undefined;
  Cidr: string | undefined;
  IpamPoolAllocationId: string | undefined;
}
export interface ReleaseIpamPoolAllocationResult {
  Success?: boolean | undefined;
}
export interface ReplaceIamInstanceProfileAssociationRequest {
  IamInstanceProfile: IamInstanceProfileSpecification | undefined;
  AssociationId: string | undefined;
}
export interface ReplaceIamInstanceProfileAssociationResult {
  IamInstanceProfileAssociation?: IamInstanceProfileAssociation | undefined;
}
export interface ReplaceNetworkAclAssociationRequest {
  DryRun?: boolean | undefined;
  AssociationId: string | undefined;
  NetworkAclId: string | undefined;
}
export interface ReplaceNetworkAclAssociationResult {
  NewAssociationId?: string | undefined;
}
export interface ReplaceNetworkAclEntryRequest {
  DryRun?: boolean | undefined;
  NetworkAclId: string | undefined;
  RuleNumber: number | undefined;
  Protocol: string | undefined;
  RuleAction: RuleAction | undefined;
  Egress: boolean | undefined;
  CidrBlock?: string | undefined;
  Ipv6CidrBlock?: string | undefined;
  IcmpTypeCode?: IcmpTypeCode | undefined;
  PortRange?: PortRange | undefined;
}
export interface ReplaceRouteRequest {
  DestinationPrefixListId?: string | undefined;
  VpcEndpointId?: string | undefined;
  LocalTarget?: boolean | undefined;
  TransitGatewayId?: string | undefined;
  LocalGatewayId?: string | undefined;
  CarrierGatewayId?: string | undefined;
  CoreNetworkArn?: string | undefined;
  DryRun?: boolean | undefined;
  RouteTableId: string | undefined;
  DestinationCidrBlock?: string | undefined;
  GatewayId?: string | undefined;
  DestinationIpv6CidrBlock?: string | undefined;
  EgressOnlyInternetGatewayId?: string | undefined;
  InstanceId?: string | undefined;
  NetworkInterfaceId?: string | undefined;
  VpcPeeringConnectionId?: string | undefined;
  NatGatewayId?: string | undefined;
}
export interface ReplaceRouteTableAssociationRequest {
  DryRun?: boolean | undefined;
  AssociationId: string | undefined;
  RouteTableId: string | undefined;
}
export interface ReplaceRouteTableAssociationResult {
  NewAssociationId?: string | undefined;
  AssociationState?: RouteTableAssociationState | undefined;
}
export interface ReplaceTransitGatewayRouteRequest {
  DestinationCidrBlock: string | undefined;
  TransitGatewayRouteTableId: string | undefined;
  TransitGatewayAttachmentId?: string | undefined;
  Blackhole?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface ReplaceTransitGatewayRouteResult {
  Route?: TransitGatewayRoute | undefined;
}
export interface ReplaceVpnTunnelRequest {
  VpnConnectionId: string | undefined;
  VpnTunnelOutsideIpAddress: string | undefined;
  ApplyPendingMaintenance?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface ReplaceVpnTunnelResult {
  Return?: boolean | undefined;
}
export declare const ReportInstanceReasonCodes: {
  readonly instance_stuck_in_state: "instance-stuck-in-state";
  readonly not_accepting_credentials: "not-accepting-credentials";
  readonly other: "other";
  readonly password_not_available: "password-not-available";
  readonly performance_ebs_volume: "performance-ebs-volume";
  readonly performance_instance_store: "performance-instance-store";
  readonly performance_network: "performance-network";
  readonly performance_other: "performance-other";
  readonly unresponsive: "unresponsive";
};
export type ReportInstanceReasonCodes =
  (typeof ReportInstanceReasonCodes)[keyof typeof ReportInstanceReasonCodes];
export declare const ReportStatusType: {
  readonly impaired: "impaired";
  readonly ok: "ok";
};
export type ReportStatusType =
  (typeof ReportStatusType)[keyof typeof ReportStatusType];
export interface ReportInstanceStatusRequest {
  DryRun?: boolean | undefined;
  Instances: string[] | undefined;
  Status: ReportStatusType | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  ReasonCodes: ReportInstanceReasonCodes[] | undefined;
  Description?: string | undefined;
}
export interface RequestSpotFleetRequest {
  DryRun?: boolean | undefined;
  SpotFleetRequestConfig: SpotFleetRequestConfigData | undefined;
}
export interface RequestSpotFleetResponse {
  SpotFleetRequestId?: string | undefined;
}
export interface RequestSpotLaunchSpecification {
  SecurityGroupIds?: string[] | undefined;
  SecurityGroups?: string[] | undefined;
  AddressingType?: string | undefined;
  BlockDeviceMappings?: BlockDeviceMapping[] | undefined;
  EbsOptimized?: boolean | undefined;
  IamInstanceProfile?: IamInstanceProfileSpecification | undefined;
  ImageId?: string | undefined;
  InstanceType?: _InstanceType | undefined;
  KernelId?: string | undefined;
  KeyName?: string | undefined;
  Monitoring?: RunInstancesMonitoringEnabled | undefined;
  NetworkInterfaces?: InstanceNetworkInterfaceSpecification[] | undefined;
  Placement?: SpotPlacement | undefined;
  RamdiskId?: string | undefined;
  SubnetId?: string | undefined;
  UserData?: string | undefined;
}
export interface RequestSpotInstancesRequest {
  LaunchSpecification?: RequestSpotLaunchSpecification | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  InstanceInterruptionBehavior?: InstanceInterruptionBehavior | undefined;
  DryRun?: boolean | undefined;
  SpotPrice?: string | undefined;
  ClientToken?: string | undefined;
  InstanceCount?: number | undefined;
  Type?: SpotInstanceType | undefined;
  ValidFrom?: Date | undefined;
  ValidUntil?: Date | undefined;
  LaunchGroup?: string | undefined;
  AvailabilityZoneGroup?: string | undefined;
  BlockDurationMinutes?: number | undefined;
}
export interface RequestSpotInstancesResult {
  SpotInstanceRequests?: SpotInstanceRequest[] | undefined;
}
export interface ResetAddressAttributeRequest {
  AllocationId: string | undefined;
  Attribute: AddressAttributeName | undefined;
  DryRun?: boolean | undefined;
}
export interface ResetAddressAttributeResult {
  Address?: AddressAttribute | undefined;
}
export interface ResetEbsDefaultKmsKeyIdRequest {
  DryRun?: boolean | undefined;
}
export interface ResetEbsDefaultKmsKeyIdResult {
  KmsKeyId?: string | undefined;
}
export declare const ResetFpgaImageAttributeName: {
  readonly loadPermission: "loadPermission";
};
export type ResetFpgaImageAttributeName =
  (typeof ResetFpgaImageAttributeName)[keyof typeof ResetFpgaImageAttributeName];
export interface ResetFpgaImageAttributeRequest {
  DryRun?: boolean | undefined;
  FpgaImageId: string | undefined;
  Attribute?: ResetFpgaImageAttributeName | undefined;
}
export interface ResetFpgaImageAttributeResult {
  Return?: boolean | undefined;
}
export declare const ResetImageAttributeName: {
  readonly launchPermission: "launchPermission";
};
export type ResetImageAttributeName =
  (typeof ResetImageAttributeName)[keyof typeof ResetImageAttributeName];
export interface ResetImageAttributeRequest {
  Attribute: ResetImageAttributeName | undefined;
  ImageId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ResetInstanceAttributeRequest {
  DryRun?: boolean | undefined;
  InstanceId: string | undefined;
  Attribute: InstanceAttributeName | undefined;
}
export interface ResetNetworkInterfaceAttributeRequest {
  DryRun?: boolean | undefined;
  NetworkInterfaceId: string | undefined;
  SourceDestCheck?: string | undefined;
}
export interface ResetSnapshotAttributeRequest {
  Attribute: SnapshotAttributeName | undefined;
  SnapshotId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface RestoreAddressToClassicRequest {
  DryRun?: boolean | undefined;
  PublicIp: string | undefined;
}
export interface RestoreAddressToClassicResult {
  PublicIp?: string | undefined;
  Status?: Status | undefined;
}
export interface RestoreImageFromRecycleBinRequest {
  ImageId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface RestoreImageFromRecycleBinResult {
  Return?: boolean | undefined;
}
export interface RestoreManagedPrefixListVersionRequest {
  DryRun?: boolean | undefined;
  PrefixListId: string | undefined;
  PreviousVersion: number | undefined;
  CurrentVersion: number | undefined;
}
export interface RestoreManagedPrefixListVersionResult {
  PrefixList?: ManagedPrefixList | undefined;
}
export interface RestoreSnapshotFromRecycleBinRequest {
  SnapshotId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface RestoreSnapshotFromRecycleBinResult {
  SnapshotId?: string | undefined;
  OutpostArn?: string | undefined;
  Description?: string | undefined;
  Encrypted?: boolean | undefined;
  OwnerId?: string | undefined;
  Progress?: string | undefined;
  StartTime?: Date | undefined;
  State?: SnapshotState | undefined;
  VolumeId?: string | undefined;
  VolumeSize?: number | undefined;
  SseType?: SSEType | undefined;
}
export interface RestoreSnapshotTierRequest {
  SnapshotId: string | undefined;
  TemporaryRestoreDays?: number | undefined;
  PermanentRestore?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface RestoreSnapshotTierResult {
  SnapshotId?: string | undefined;
  RestoreStartTime?: Date | undefined;
  RestoreDuration?: number | undefined;
  IsPermanentRestore?: boolean | undefined;
}
export interface RevokeClientVpnIngressRequest {
  ClientVpnEndpointId: string | undefined;
  TargetNetworkCidr: string | undefined;
  AccessGroupId?: string | undefined;
  RevokeAllGroups?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface RevokeClientVpnIngressResult {
  Status?: ClientVpnAuthorizationRuleStatus | undefined;
}
export interface RevokeSecurityGroupEgressRequest {
  SecurityGroupRuleIds?: string[] | undefined;
  DryRun?: boolean | undefined;
  GroupId: string | undefined;
  SourceSecurityGroupName?: string | undefined;
  SourceSecurityGroupOwnerId?: string | undefined;
  IpProtocol?: string | undefined;
  FromPort?: number | undefined;
  ToPort?: number | undefined;
  CidrIp?: string | undefined;
  IpPermissions?: IpPermission[] | undefined;
}
export interface RevokedSecurityGroupRule {
  SecurityGroupRuleId?: string | undefined;
  GroupId?: string | undefined;
  IsEgress?: boolean | undefined;
  IpProtocol?: string | undefined;
  FromPort?: number | undefined;
  ToPort?: number | undefined;
  CidrIpv4?: string | undefined;
  CidrIpv6?: string | undefined;
  PrefixListId?: string | undefined;
  ReferencedGroupId?: string | undefined;
  Description?: string | undefined;
}
export interface RevokeSecurityGroupEgressResult {
  Return?: boolean | undefined;
  UnknownIpPermissions?: IpPermission[] | undefined;
  RevokedSecurityGroupRules?: RevokedSecurityGroupRule[] | undefined;
}
export interface RevokeSecurityGroupIngressRequest {
  CidrIp?: string | undefined;
  FromPort?: number | undefined;
  GroupId?: string | undefined;
  GroupName?: string | undefined;
  IpPermissions?: IpPermission[] | undefined;
  IpProtocol?: string | undefined;
  SourceSecurityGroupName?: string | undefined;
  SourceSecurityGroupOwnerId?: string | undefined;
  ToPort?: number | undefined;
  SecurityGroupRuleIds?: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface RevokeSecurityGroupIngressResult {
  Return?: boolean | undefined;
  UnknownIpPermissions?: IpPermission[] | undefined;
  RevokedSecurityGroupRules?: RevokedSecurityGroupRule[] | undefined;
}
export interface CpuOptionsRequest {
  CoreCount?: number | undefined;
  ThreadsPerCore?: number | undefined;
  AmdSevSnp?: AmdSevSnpSpecification | undefined;
}
export interface ElasticInferenceAccelerator {
  Type: string | undefined;
  Count?: number | undefined;
}
export interface EnclaveOptionsRequest {
  Enabled?: boolean | undefined;
}
export interface HibernationOptionsRequest {
  Configured?: boolean | undefined;
}
export interface SpotMarketOptions {
  MaxPrice?: string | undefined;
  SpotInstanceType?: SpotInstanceType | undefined;
  BlockDurationMinutes?: number | undefined;
  ValidUntil?: Date | undefined;
  InstanceInterruptionBehavior?: InstanceInterruptionBehavior | undefined;
}
export interface InstanceMarketOptionsRequest {
  MarketType?: MarketType | undefined;
  SpotOptions?: SpotMarketOptions | undefined;
}
export interface LaunchTemplateSpecification {
  LaunchTemplateId?: string | undefined;
  LaunchTemplateName?: string | undefined;
  Version?: string | undefined;
}
export interface LicenseConfigurationRequest {
  LicenseConfigurationArn?: string | undefined;
}
export interface InstanceMaintenanceOptionsRequest {
  AutoRecovery?: InstanceAutoRecoveryState | undefined;
}
export interface InstanceMetadataOptionsRequest {
  HttpTokens?: HttpTokensState | undefined;
  HttpPutResponseHopLimit?: number | undefined;
  HttpEndpoint?: InstanceMetadataEndpointState | undefined;
  HttpProtocolIpv6?: InstanceMetadataProtocolState | undefined;
  InstanceMetadataTags?: InstanceMetadataTagsState | undefined;
}
export interface PrivateDnsNameOptionsRequest {
  HostnameType?: HostnameType | undefined;
  EnableResourceNameDnsARecord?: boolean | undefined;
  EnableResourceNameDnsAAAARecord?: boolean | undefined;
}
export interface RunInstancesRequest {
  BlockDeviceMappings?: BlockDeviceMapping[] | undefined;
  ImageId?: string | undefined;
  InstanceType?: _InstanceType | undefined;
  Ipv6AddressCount?: number | undefined;
  Ipv6Addresses?: InstanceIpv6Address[] | undefined;
  KernelId?: string | undefined;
  KeyName?: string | undefined;
  MaxCount: number | undefined;
  MinCount: number | undefined;
  Monitoring?: RunInstancesMonitoringEnabled | undefined;
  Placement?: Placement | undefined;
  RamdiskId?: string | undefined;
  SecurityGroupIds?: string[] | undefined;
  SecurityGroups?: string[] | undefined;
  SubnetId?: string | undefined;
  UserData?: string | undefined;
  ElasticGpuSpecification?: ElasticGpuSpecification[] | undefined;
  ElasticInferenceAccelerators?: ElasticInferenceAccelerator[] | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  LaunchTemplate?: LaunchTemplateSpecification | undefined;
  InstanceMarketOptions?: InstanceMarketOptionsRequest | undefined;
  CreditSpecification?: CreditSpecificationRequest | undefined;
  CpuOptions?: CpuOptionsRequest | undefined;
  CapacityReservationSpecification?:
    | CapacityReservationSpecification
    | undefined;
  HibernationOptions?: HibernationOptionsRequest | undefined;
  LicenseSpecifications?: LicenseConfigurationRequest[] | undefined;
  MetadataOptions?: InstanceMetadataOptionsRequest | undefined;
  EnclaveOptions?: EnclaveOptionsRequest | undefined;
  PrivateDnsNameOptions?: PrivateDnsNameOptionsRequest | undefined;
  MaintenanceOptions?: InstanceMaintenanceOptionsRequest | undefined;
  DisableApiStop?: boolean | undefined;
  EnablePrimaryIpv6?: boolean | undefined;
  Operator?: OperatorRequest | undefined;
  DryRun?: boolean | undefined;
  DisableApiTermination?: boolean | undefined;
  InstanceInitiatedShutdownBehavior?: ShutdownBehavior | undefined;
  PrivateIpAddress?: string | undefined;
  ClientToken?: string | undefined;
  AdditionalInfo?: string | undefined;
  NetworkInterfaces?: InstanceNetworkInterfaceSpecification[] | undefined;
  IamInstanceProfile?: IamInstanceProfileSpecification | undefined;
  EbsOptimized?: boolean | undefined;
}
export interface ScheduledInstancesEbs {
  DeleteOnTermination?: boolean | undefined;
  Encrypted?: boolean | undefined;
  Iops?: number | undefined;
  SnapshotId?: string | undefined;
  VolumeSize?: number | undefined;
  VolumeType?: string | undefined;
}
export interface ScheduledInstancesBlockDeviceMapping {
  DeviceName?: string | undefined;
  Ebs?: ScheduledInstancesEbs | undefined;
  NoDevice?: string | undefined;
  VirtualName?: string | undefined;
}
export interface ScheduledInstancesIamInstanceProfile {
  Arn?: string | undefined;
  Name?: string | undefined;
}
export interface ScheduledInstancesMonitoring {
  Enabled?: boolean | undefined;
}
export interface ScheduledInstancesIpv6Address {
  Ipv6Address?: string | undefined;
}
export interface ScheduledInstancesPrivateIpAddressConfig {
  Primary?: boolean | undefined;
  PrivateIpAddress?: string | undefined;
}
export interface ScheduledInstancesNetworkInterface {
  AssociatePublicIpAddress?: boolean | undefined;
  DeleteOnTermination?: boolean | undefined;
  Description?: string | undefined;
  DeviceIndex?: number | undefined;
  Groups?: string[] | undefined;
  Ipv6AddressCount?: number | undefined;
  Ipv6Addresses?: ScheduledInstancesIpv6Address[] | undefined;
  NetworkInterfaceId?: string | undefined;
  PrivateIpAddress?: string | undefined;
  PrivateIpAddressConfigs?:
    | ScheduledInstancesPrivateIpAddressConfig[]
    | undefined;
  SecondaryPrivateIpAddressCount?: number | undefined;
  SubnetId?: string | undefined;
}
export interface ScheduledInstancesPlacement {
  AvailabilityZone?: string | undefined;
  GroupName?: string | undefined;
}
export interface ScheduledInstancesLaunchSpecification {
  BlockDeviceMappings?: ScheduledInstancesBlockDeviceMapping[] | undefined;
  EbsOptimized?: boolean | undefined;
  IamInstanceProfile?: ScheduledInstancesIamInstanceProfile | undefined;
  ImageId: string | undefined;
  InstanceType?: string | undefined;
  KernelId?: string | undefined;
  KeyName?: string | undefined;
  Monitoring?: ScheduledInstancesMonitoring | undefined;
  NetworkInterfaces?: ScheduledInstancesNetworkInterface[] | undefined;
  Placement?: ScheduledInstancesPlacement | undefined;
  RamdiskId?: string | undefined;
  SecurityGroupIds?: string[] | undefined;
  SubnetId?: string | undefined;
  UserData?: string | undefined;
}
export interface RunScheduledInstancesRequest {
  ClientToken?: string | undefined;
  DryRun?: boolean | undefined;
  InstanceCount?: number | undefined;
  LaunchSpecification: ScheduledInstancesLaunchSpecification | undefined;
  ScheduledInstanceId: string | undefined;
}
export interface RunScheduledInstancesResult {
  InstanceIdSet?: string[] | undefined;
}
export interface SearchLocalGatewayRoutesRequest {
  LocalGatewayRouteTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface SearchLocalGatewayRoutesResult {
  Routes?: LocalGatewayRoute[] | undefined;
  NextToken?: string | undefined;
}
export interface SearchTransitGatewayMulticastGroupsRequest {
  TransitGatewayMulticastDomainId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export declare const MembershipType: {
  readonly igmp: "igmp";
  readonly static: "static";
};
export type MembershipType =
  (typeof MembershipType)[keyof typeof MembershipType];
export interface TransitGatewayMulticastGroup {
  GroupIpAddress?: string | undefined;
  TransitGatewayAttachmentId?: string | undefined;
  SubnetId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceType?: TransitGatewayAttachmentResourceType | undefined;
  ResourceOwnerId?: string | undefined;
  NetworkInterfaceId?: string | undefined;
  GroupMember?: boolean | undefined;
  GroupSource?: boolean | undefined;
  MemberType?: MembershipType | undefined;
  SourceType?: MembershipType | undefined;
}
export interface SearchTransitGatewayMulticastGroupsResult {
  MulticastGroups?: TransitGatewayMulticastGroup[] | undefined;
  NextToken?: string | undefined;
}
export interface SearchTransitGatewayRoutesRequest {
  TransitGatewayRouteTableId: string | undefined;
  Filters: Filter[] | undefined;
  MaxResults?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface SearchTransitGatewayRoutesResult {
  Routes?: TransitGatewayRoute[] | undefined;
  AdditionalRoutesAvailable?: boolean | undefined;
}
export interface SendDiagnosticInterruptRequest {
  InstanceId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface StartInstancesRequest {
  InstanceIds: string[] | undefined;
  AdditionalInfo?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface InstanceStateChange {
  InstanceId?: string | undefined;
  CurrentState?: InstanceState | undefined;
  PreviousState?: InstanceState | undefined;
}
export interface StartInstancesResult {
  StartingInstances?: InstanceStateChange[] | undefined;
}
export interface StartNetworkInsightsAccessScopeAnalysisRequest {
  NetworkInsightsAccessScopeId: string | undefined;
  DryRun?: boolean | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  ClientToken?: string | undefined;
}
export interface StartNetworkInsightsAccessScopeAnalysisResult {
  NetworkInsightsAccessScopeAnalysis?:
    | NetworkInsightsAccessScopeAnalysis
    | undefined;
}
export interface StartNetworkInsightsAnalysisRequest {
  NetworkInsightsPathId: string | undefined;
  AdditionalAccounts?: string[] | undefined;
  FilterInArns?: string[] | undefined;
  DryRun?: boolean | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  ClientToken?: string | undefined;
}
export interface StartNetworkInsightsAnalysisResult {
  NetworkInsightsAnalysis?: NetworkInsightsAnalysis | undefined;
}
export interface StartVpcEndpointServicePrivateDnsVerificationRequest {
  DryRun?: boolean | undefined;
  ServiceId: string | undefined;
}
export interface StartVpcEndpointServicePrivateDnsVerificationResult {
  ReturnValue?: boolean | undefined;
}
export interface StopInstancesRequest {
  InstanceIds: string[] | undefined;
  Hibernate?: boolean | undefined;
  DryRun?: boolean | undefined;
  Force?: boolean | undefined;
}
export interface StopInstancesResult {
  StoppingInstances?: InstanceStateChange[] | undefined;
}
export interface TerminateClientVpnConnectionsRequest {
  ClientVpnEndpointId: string | undefined;
  ConnectionId?: string | undefined;
  Username?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TerminateConnectionStatus {
  ConnectionId?: string | undefined;
  PreviousStatus?: ClientVpnConnectionStatus | undefined;
  CurrentStatus?: ClientVpnConnectionStatus | undefined;
}
export interface TerminateClientVpnConnectionsResult {
  ClientVpnEndpointId?: string | undefined;
  Username?: string | undefined;
  ConnectionStatuses?: TerminateConnectionStatus[] | undefined;
}
export interface TerminateInstancesRequest {
  InstanceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface TerminateInstancesResult {
  TerminatingInstances?: InstanceStateChange[] | undefined;
}
export interface UnassignIpv6AddressesRequest {
  Ipv6Prefixes?: string[] | undefined;
  NetworkInterfaceId: string | undefined;
  Ipv6Addresses?: string[] | undefined;
}
export interface UnassignIpv6AddressesResult {
  NetworkInterfaceId?: string | undefined;
  UnassignedIpv6Addresses?: string[] | undefined;
  UnassignedIpv6Prefixes?: string[] | undefined;
}
export interface UnassignPrivateIpAddressesRequest {
  Ipv4Prefixes?: string[] | undefined;
  NetworkInterfaceId: string | undefined;
  PrivateIpAddresses?: string[] | undefined;
}
export interface UnassignPrivateNatGatewayAddressRequest {
  NatGatewayId: string | undefined;
  PrivateIpAddresses: string[] | undefined;
  MaxDrainDurationSeconds?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface UnassignPrivateNatGatewayAddressResult {
  NatGatewayId?: string | undefined;
  NatGatewayAddresses?: NatGatewayAddress[] | undefined;
}
export interface UnlockSnapshotRequest {
  SnapshotId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface UnlockSnapshotResult {
  SnapshotId?: string | undefined;
}
export interface UnmonitorInstancesRequest {
  InstanceIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface UnmonitorInstancesResult {
  InstanceMonitorings?: InstanceMonitoring[] | undefined;
}
export interface SecurityGroupRuleDescription {
  SecurityGroupRuleId?: string | undefined;
  Description?: string | undefined;
}
export interface UpdateSecurityGroupRuleDescriptionsEgressRequest {
  DryRun?: boolean | undefined;
  GroupId?: string | undefined;
  GroupName?: string | undefined;
  IpPermissions?: IpPermission[] | undefined;
  SecurityGroupRuleDescriptions?: SecurityGroupRuleDescription[] | undefined;
}
export interface UpdateSecurityGroupRuleDescriptionsEgressResult {
  Return?: boolean | undefined;
}
export interface UpdateSecurityGroupRuleDescriptionsIngressRequest {
  DryRun?: boolean | undefined;
  GroupId?: string | undefined;
  GroupName?: string | undefined;
  IpPermissions?: IpPermission[] | undefined;
  SecurityGroupRuleDescriptions?: SecurityGroupRuleDescription[] | undefined;
}
export interface UpdateSecurityGroupRuleDescriptionsIngressResult {
  Return?: boolean | undefined;
}
export interface WithdrawByoipCidrRequest {
  Cidr: string | undefined;
  DryRun?: boolean | undefined;
}
export interface WithdrawByoipCidrResult {
  ByoipCidr?: ByoipCidr | undefined;
}
export declare const ModifyVerifiedAccessTrustProviderOidcOptionsFilterSensitiveLog: (
  obj: ModifyVerifiedAccessTrustProviderOidcOptions
) => any;
export declare const ModifyVerifiedAccessTrustProviderRequestFilterSensitiveLog: (
  obj: ModifyVerifiedAccessTrustProviderRequest
) => any;
export declare const ModifyVerifiedAccessTrustProviderResultFilterSensitiveLog: (
  obj: ModifyVerifiedAccessTrustProviderResult
) => any;
export declare const ModifyVpnConnectionResultFilterSensitiveLog: (
  obj: ModifyVpnConnectionResult
) => any;
export declare const ModifyVpnConnectionOptionsResultFilterSensitiveLog: (
  obj: ModifyVpnConnectionOptionsResult
) => any;
export declare const ModifyVpnTunnelCertificateResultFilterSensitiveLog: (
  obj: ModifyVpnTunnelCertificateResult
) => any;
export declare const ModifyVpnTunnelOptionsSpecificationFilterSensitiveLog: (
  obj: ModifyVpnTunnelOptionsSpecification
) => any;
export declare const ModifyVpnTunnelOptionsRequestFilterSensitiveLog: (
  obj: ModifyVpnTunnelOptionsRequest
) => any;
export declare const ModifyVpnTunnelOptionsResultFilterSensitiveLog: (
  obj: ModifyVpnTunnelOptionsResult
) => any;
export declare const ReportInstanceStatusRequestFilterSensitiveLog: (
  obj: ReportInstanceStatusRequest
) => any;
export declare const RequestSpotFleetRequestFilterSensitiveLog: (
  obj: RequestSpotFleetRequest
) => any;
export declare const RequestSpotLaunchSpecificationFilterSensitiveLog: (
  obj: RequestSpotLaunchSpecification
) => any;
export declare const RequestSpotInstancesRequestFilterSensitiveLog: (
  obj: RequestSpotInstancesRequest
) => any;
export declare const RequestSpotInstancesResultFilterSensitiveLog: (
  obj: RequestSpotInstancesResult
) => any;
export declare const RunInstancesRequestFilterSensitiveLog: (
  obj: RunInstancesRequest
) => any;
export declare const ScheduledInstancesLaunchSpecificationFilterSensitiveLog: (
  obj: ScheduledInstancesLaunchSpecification
) => any;
export declare const RunScheduledInstancesRequestFilterSensitiveLog: (
  obj: RunScheduledInstancesRequest
) => any;
